
%define name	flash-player-plugin-preview
# see http://www.adobe.com/software/flash/about/ for version test
%define version	10.3.162.29
%define plev	p3
%define tardate	111710
%define rel	1

%define distsuffix plf
# backportability
%define _localstatedir /var

Summary:	Flash Player plugin for browsers - preview beta release
Name:		%name
Version:	%version
Release:	%mkrel %rel
License:	Proprietary
URL:		http://www.adobe.com/products/flashplayer/
Source0:	download-flash-player-plugin.in
Group:		Networking/WWW
ExclusiveArch:	x86_64
Requires:	curl
Requires(post):	curl
BuildRoot:	%{_tmppath}/%{name}-root

# obtained by objdump -x /usr/lib/mozilla/plugins/libflashplayer.so | grep NEEDED
# helper: for i in $(objdump -p libflashplayer.so  | grep NEEDED | awk '{ print $2 }'); do
#	  echo -n "$i: "; rpm -qf /usr/lib64/$i; done
#		libX11.so.6	libXext.so.6	libXt.so.6	libfreetype.so.6
Requires:	%{_lib}x11_6	%{_lib}xext6	%{_lib}xt6	%{_lib}freetype6
#		libfontconfig.so.1	libgtk-x11-2.0.so.0, libgdk-x11-2.0.so.0
Requires:       %{_lib}fontconfig1	%{_lib}gtk+-x11-2.0_0
#		libatk-1.0.so.0	libgdk_pixbuf-2.0.so.0	libpangocairo-1.0.so.0, libpango-1.0.so.0
Requires:	%{_lib}atk1.0_0	%{_lib}gdk_pixbuf2.0_0	%{_lib}pango1.0_0
#		libcairo.so.2	libgobject-2.0.so.0, libgmodule-2.0.so.0, libglib-2.0.so.0
Requires:	%{_lib}cairo2	%{_lib}glib2.0_0
#		libnss3.so, libsmime3.so, libssl3.so	libplds4.so, libplc4.so, libnspr4.so
Requires:	%{_lib}nss3				%{_lib}nspr4
# required for audio, dlopened:
Requires:	%{_lib}alsa2
# dlopened:
%if %{mdkversion} >= 200710
Requires:	%{_lib}curl4
%else
Requires:	%{_lib}curl3
%endif
#
Conflicts:	FlashPlayer < 9.0.115.0-5
Conflicts:	flash-plugin FlashPlayer-plugin flashplayer-plugin
Conflicts:	flash-player-plugin < %{version}-%{release}
%ifarch x86_64
# there is no stable flash-player-plugin on x86_64
Provides:	flash-player-plugin = %{version}-%{release}
%endif
# Conflict with free plugins to avoid user confusion as to which one is
# actually used:
Conflicts:	gnash-firefox-plugin
Conflicts:	swfdec-mozilla
Conflicts:	lightspark-mozilla-plugin
Conflicts:	libflashsupport < 0.20080000.1

%description
Adobe Flash Player plugin for browsers. Preview beta release.

NOTE: This package does not contain the Flash Player itself. The
software will be automatically downloaded from Adobe during package
installation. Alternatively you can use the command
"download-flash-player-plugin" manually.

Installing this package indicates your acceptance of the following
documents:
- Flash Player 10 License:
  http://labs.adobe.com/technologies/eula/flashplayer10.html
- Adobe.com Terms of Use: http://www.adobe.com/misc/terms.html
- Adobe Online Privacy Policy: http://www.adobe.com/misc/privacy.html

This package is in PLF because it installs software with non-free
license.

%prep
%setup -c -T

# The linuxdownload.adobe.com rpm usually stays up longer, but fpdownload.macromedia.com is faster.
# Their md5sums differ.
%ifarch %ix86
%define downurl1 http://download.macromedia.com/pub/labs/flashplayer10/flashplayer10_2_%{plev}_32bit_linux_%{tardate}.tar.gz
%define tmd5sum1 3a5c1e0a77bb44d3456c933a056bcf47
%define downurl2 %nil
%define tmd5sum2 %nil
%define tarname flashplayer10_2_%{plev}_32bit_linux_%{tardate}.tar.gz
%define tartype	tar
%define srcdir	%nil
%endif
%ifarch x86_64
%define downurl1 http://download.macromedia.com/pub/labs/flashplayer10/flashplayer10_2_%{plev}_64bit_linux_%{tardate}.tar.gz
%define tmd5sum1 49b55c7eb8044453e5f6f2e4b3cb4084
%define downurl2 %nil
%define tmd5sum2 %nil
%define tarname flashplayer10_2_%{plev}_64bit_linux_%{tardate}.tar.gz
%define tartype tar
%define srcdir  %nil
%endif

cat > download-flash-player-plugin <<EOF
#!/bin/sh
TARBALLDIR="%{_localstatedir}/lib/%{name}"
FILENAME="%{tarname}"
FILETYPE="%{tartype}"
MD5SUM1="%{tmd5sum1}"
MD5SUM2="%{tmd5sum2}"
MD5SUM3=
URL1="%{downurl1}"
URL2="%{downurl2}"
URL3=
FILE1_SRC="%{srcdir}libflashplayer.so"
FILE1_DST="%{_libdir}/mozilla/plugins/libflashplayer.so"
FILE2_SRC=
EOF
cat %SOURCE0 >> download-flash-player-plugin

%ifarch %ix86
cat >> download-flash-player-plugin <<EOF
if [ "\$(uname -m)" == x86_64 ]; then
	if [ -x %{_bindir}/nspluginwrapper ]; then
		echo "Detected x86_64 with nspluginwrapper, enabling the plugin on 64bit browsers too."
		%{_bindir}/nspluginwrapper -i %{_libdir}/mozilla/plugins/libflashplayer.so
	else
		echo "Install nspluginwrapper if you want to use the plugin with 64bit browsers too."
	fi
fi
EOF
%endif

%install
rm -rf %{buildroot}

install -d -m755 %{buildroot}%{_localstatedir}/lib/%{name}
install -d -m755 %{buildroot}%{_libdir}/mozilla/plugins
%if %mdkversion < 200800
install -d -m755 %{buildroot}%{_libdir}/opera/plugins
ln -s %{_libdir}/mozilla/plugins/libflashplayer.so %{buildroot}%{_libdir}/opera/plugins/libflashplayer.so
%endif
touch %{buildroot}%{_libdir}/mozilla/plugins/libflashplayer.so
touch %{buildroot}%{_localstatedir}/lib/%{name}/%{tarname}

install -d -m755 %{buildroot}%{_sbindir}
install -m755 download-flash-player-plugin %{buildroot}%{_sbindir}

%clean
rm -rf %{buildroot}

# posttrans so that we can use postun safely without if's :)
%posttrans
%{_sbindir}/download-flash-player-plugin

%ifarch %ix86
%postun
if [ -x %{_bindir}/nspluginwrapper ] && [ "$(uname -m)" == x86_64 ] && [ -f %{_prefix}/lib64/mozilla/plugins/npwrapper.libflashplayer.so ]; then
	%{_bindir}/nspluginwrapper -r %{_prefix}/lib64/mozilla/plugins/npwrapper.libflashplayer.so
fi
%endif

%files
%defattr(-,root,root)
%{_sbindir}/download-flash-player-plugin
%dir %{_localstatedir}/lib/%{name}
%ghost %{_localstatedir}/lib/%{name}/%{tarname}
%dir %{_libdir}/mozilla
%dir %{_libdir}/mozilla/plugins
%ghost %{_libdir}/mozilla/plugins/libflashplayer.so
%if %mdkversion < 200800
%{_libdir}/opera
%endif

%changelog
* Wed Dec 02 2010 Anssi Hannula <anssi@zarb.org> 10.3.162.29-1plf2011.0
- new preview version ("Square" Preview, p3 111710)
  o 64 bit version only (for 32 bit version, see flash-player-plugin10.2)
  o no VDPAU support (for that, see flash-player-plugin10.2)

* Sat Oct 02 2010 Anssi Hannula <anssi@zarb.org> 10.2.161.23-1plf2011.0
- new beta version
  o fixes CVE-2010-2884

* Thu Sep 16 2010 Anssi Hannula <anssi@zarb.org> 10.2.161.22-1plf2011.0
- new beta version in a differently named package
  o x86_64 version provided again

* Thu Aug 12 2010 Anssi Hannula <anssi@zarb.org> 10.1.82.76-1plf2010.1
- new version

* Fri Jun 11 2010 Anssi Hannula <anssi@zarb.org> 10.1.53.64-1plf2010.1
- new version
- remove LAHF workaround, should be fixed upstream
- disable x86_64 build, Adobe no longer provides a 64-bit version

* Tue May 11 2010 Anssi Hannula <anssi@zarb.org> 10.0.45.2-3plf2010.1
- include a workaround for a crash on non-LAHF x86_64 systems (fixes PLF
  bug #260, workarounds upstream bug FP-1026, workaround by Maks Verver)
- preserve tarball to avoid a redownload after a rebuild
  
* Fri Apr 16 2010 Anssi Hannula <anssi@zarb.org> 10.0.45.2-2plf2010.1
- conflict with flashplayer-plugin (new name of the mdv pwp package)
- conflict with swfdec-mozilla and gnash-firefox-plugin to avoid user
  confusion as to which one is actually in use (fixes bug #271)

* Thu Feb 18 2010 Anssi Hannula <anssi@zarb.org> 10.0.45.2-1plf2010.1
- new version

* Fri Dec 11 2009 Anssi Hannula <anssi@zarb.org> 10.0.42.34-1plf2010.1
- new version
- build on x86_64, using the alpha x86_64 build
- use faster fpdownload as primary download host
- conflicts with old libflashsupport

* Sun Aug 02 2009 Anssi Hannula <anssi@zarb.org> 10.0.32.18-1plf2010.0
- new version
- adapt spec for redefined _localstatedir

* Mon Mar 02 2009 Anssi Hannula <anssi@zarb.org> 10.0.22.87-1plf2009.1
- new version

* Sat Feb 21 2009 Anssi Hannula <anssi@zarb.org> 10.0.15.3-1plf2009.1
- new version
- update instructions in case of failed download

* Wed Oct 22 2008 Anssi Hannula <anssi@zarb.org> 10.0.12.36-2plf2009.1
- requires libnss3 and libnspr4 specifically, instead of the library names,
  as those are provided by multiple packages on some releases

* Sun Oct 19 2008 Anssi Hannula <anssi@zarb.org> 10.0.12.36-1plf2009.1
- new version

* Tue Apr 15 2008 Anssi Hannula <anssi@zarb.org> 9.0.124.0-1plf2009.0
- new version
- suggests libflashsupport (#193)
- adapt conflicts to new Mandriva restricted FlashPlayer packages

* Fri Dec 07 2007 Anssi Hannula <anssi@zarb.org> 9.0.115.0-2plf2008.1
- better error message on md5sum mismatch (#178)
- fix error on upgrade (#178)
- use versioned rpm instead of tarball (#178)

* Thu Dec  6 2007 Götz Waschk <goetz@zarb.org> 9.0.115.0-1plf2008.1
- new version

* Sun Oct 14 2007 Anssi Hannula <anssi@zarb.org> 9.0.64.0-1plf2008.0
- 9.0.64.0 (Colin Guthrie)

* Wed Jul 11 2007 Anssi Hannula <anssi@zarb.org> 9.0.48.0-1plf2008.0
- 9.0.48.0

* Sun Jan 21 2007 Anssi Hannula <anssi@zarb.org> 9.0.31.0-1plf2007.1
- 9.0.31.0

* Tue Nov 21 2006 Götz Waschk <goetz@zarb.org> 9.0.21.78-1plf2007.1
- new version

* Sat Nov 11 2006 Anssi Hannula <anssi@zarb.org> 9.0.21.55-4plf2007.1
- add additional check in postun on x86_64
- use ndiswrapper -i instead of -u on upgrade on x86_64

* Wed Nov 01 2006 Anssi Hannula <anssi@zarb.org> 9.0.21.55-3plf2007.1
- manage nspluginwrapper automatically on x86_64
- add conflicts

* Wed Nov 01 2006 Anssi Hannula <anssi@zarb.org> 9.0.21.55-2plf2007.1
- add manual dependencies

* Wed Nov 01 2006 Anssi Hannula <anssi@zarb.org> 9.0.21.55-1plf2007.1
- initial PLF release
